﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Web.Http;
using Kreta.Naplo.BusinessLogic.V3.Dummy;
using Kreta.Naplo.Domain.V3.Enum;
using Kreta.Naplo.WebApi.FilterAttributes;
using Kreta.Naplo.WebApi.V3.Common.Logic;
using Kreta.Naplo.WebApi.V3.Documentation;
using Kreta.Web.Logging.Abstractions;
using Swashbuckle.Swagger.Annotations;

namespace Kreta.Naplo.WebApi.V3.Controllers
{
    [ApiKeyAuthorization]
    [IdpAuthorize(FelhasznaloSzerepkor.Tanar)]
    [RoutePrefix(Constants.RoutePrefix + "/Dummy")]
    public class DummyController : ApiController
    {
        private ITraceLogger TraceLogger { get; }

        public DummyController(ITraceLogger traceLogger)
        {
            TraceLogger = traceLogger ?? throw new ArgumentNullException(nameof(traceLogger));
        }

        [HttpGet, Route("TraceLoggerDummy")]
        [SwaggerResponse(HttpStatusCode.OK, DescriptionLookUp.TraceDummyResponseLeiras, typeof(List<object>))]
        public List<object> TraceLoggerDummy()
        {
            return ((DummyFacade)Activator.CreateInstance(typeof(DummyFacade), FelhasznaloLogic.GetFelhasznalo(), TraceLogger)).TraceLoggerDummy();
        }
    }
}
